type TDigital
  as integer x, y, w, h
  declare constructor
  declare constructor(x as integer, y as integer, w as integer, h as integer)
end type

constructor TDigital
end constructor
constructor TDigital(x as integer, y as integer, w as integer, h as integer)
  this.x = x
  this.y = y
  this.w = w
  this.h = h
end constructor

declare sub zeichenNr(x as integer, y as integer, nr as integer, farbe as integer = &hffffff)
declare sub zeichenAsc(x as integer, as integer, s as string, farbe as integer = &hffffff)
declare sub zeichenZeichnen(x as integer, y as integer, id as integer, farbe as integer = &hffffff)

sub zeichenNr(x as integer, y as integer, nr as integer, farbe as integer = &hffffff)
  ' Ziffern
  static z(9) as integer = {365, 288, 103, 295, 298, 271, 335, 289, 367, 303}
  if nr >= 0 and nr < 10 then zeichenZeichnen x, y, z(nr), farbe
end sub
sub zeichenAsc(x as integer, y as integer, s as string, farbe as integer = &hffffff)
  ' Buchstaben
  static z(25) as integer = {363, 367, 77, 365, 79, 75, 335, 362, 144, 292, 3144, 76, 74088, _
                             270696, 365, 107, 262509, 2155, 271, 145, 364, 1179688, 786792, 860160, 170, 589829}
  select case as const asc(s)
    case asc("A") to asc("Z") : zeichenZeichnen x, y, z(asc(s) - asc("A")), farbe
    case asc("0") to asc("9") : zeichenNr x, y, valint(s), farbe
    case asc("b")             : zeichenzeichnen x, y, 334, farbe
  end select
end sub
sub zeichenZeichnen(x as integer, y as integer, id as integer, farbe as integer = &hffffff)
  ' spezial: 1: 1312: b: 334; x: 6144; z: 4102
  static as TDigital s(20) = { _
    TDigital( 2,  0,  7, 0), _
    TDigital( 2, 10,  7, 0), _
    TDigital( 2, 20,  7, 0), _
    TDigital( 0,  0,  0, 8), _
    TDigital( 5,  0,  0, 8), _
    TDigital(10,  0,  0, 8), _
    TDigital( 0, 10,  0, 9), _
    TDigital( 5, 10,  0, 9), _
    TDigital(10, 10,  0, 9), _
    TDigital( 0,  0,  9, 9), _
    TDigital(10,  0, -9, 9), _
    TDigital( 0, 10,  9, 9), _
    TDigital(10, 10, -9, 9), _
    TDigital( 0,  0,  4, 8), _
    TDigital( 5,  0,  4, 8), _
    TDigital( 5,  0, -4, 8), _
    TDigital(10,  0, -4, 8), _
    TDigital( 0, 10,  4, 8), _
    TDigital( 5, 10,  4, 8), _
    TDigital( 5, 10, -4, 8), _
    TDigital(10, 10, -4, 8) _
  }
  for i as integer = 0 to ubound(s)
    if bit(id, i) then
      line(x + s(i).x + sgn(s(i).h), y + s(i).y - sgn(s(i).w))-step(s(i).w, s(i).h), farbe
      line(x + s(i).x + sgn(s(i).h), y + s(i).y)-step(s(i).w, s(i).h), farbe
      line(x + s(i).x, y + s(i).y)-step(s(i).w, s(i).h), farbe
    end if
  next
end sub
